Name: bzip2
%define	v_major	1
%define	v_minor	0
%define	v_patch	3
Version: %v_major.%v_minor.%v_patch
Release: alt5
Serial: 1

Summary: Extremely powerful file compression utility
License: BSD-like
Group: Archiving/Compression
Url: http://www.bzip.org/

Source: http://www.bzip.org/%version/%name-%version.tar.gz
Source2: bzlib_triggerpostun.c
Source3: %name.texi

Patch1: %name-1.0.3-alt-autotools.patch
Patch2: %name-1.0.3-alt-compat.patch
Patch3: %name-1.0.2-alt-bzdiff-tmp.patch
Patch4: %name-1.0.3-alt-fopen.patch
Patch5: %name-1.0.3-alt-const.patch
Patch6: %name-1.0.3-alt-chmod-chown.patch
Patch7: %name-1.0.3-alt-progname.patch
Patch8: %name-1.0.3-flok-show-progress.patch

Provides: /bin/bunzip, /bin/bunzip2, /bin/bzcat, /bin/bzip, /bin/bzip2
PreReq: bzlib = %version-%release

BuildPreReq: glibc-devel-static

%package -n bzlib
Summary: The bzlib compression and decompression library
Summary(ru_RU.KOI8-R):    bzlib
Group: System/Libraries
Provides: libbz2.so.%v_major.%v_minor, libbz2.so.%v_major, libbz2.so.0, libbz2.so.0.9
Provides: /sbin/bzlib_triggerpostun

%package -n bzlib-devel
Summary: Include files for developing apps which will use %name
Group: Development/C
Provides: %name-devel = %version, libbz2.so
Obsoletes: %name-devel
PreReq: bzlib = %version-%release
Requires(post): %install_info
Requires(preun): %uninstall_info

%package -n bzlib-devel-static
Summary: Static library for developing apps which will use %name
Group: Development/C
Provides: %name-devel-static = %version
Obsoletes: %name-devel-static
Requires: bzlib-devel = %version-%release

%package doc
Summary: Documentation for developing apps which will use %name
Group: Development/C
Requires: %name = %version-%release

%description
bzip2 is a freely available, patent-free, high quality data compressor.

bzip2 compresses files using the Burrows-Wheeler block sorting
text compression algorithm and Huffman coding.  Compression is
generally considerably better than that achieved by more conventional
LZ77/LZ78-based compressors (such as gzip), and approaches the performance
of the PPM family of statistical compressors.  bzip2 is by far not the
fastest compression utility, but it does strike a balance between speed
and compression capability.

The command-line options are deliberately very similar to those of
GNU Gzip, but they are not identical.

%description -n bzlib
The %name compression library provides in-memory compression and
decompression functions, including integrity checks of the uncompressed
data.  The %name library is used by many different system programs.

%description -n bzlib-devel
This package contains the include files needed to develop programs that
use the %name compression and decompression library.

%description -n bzlib-devel-static
This package contains the static library needed to develop statically
linked programs that use the %name compression and decompression library.

%description doc
This package contains additional documentation on %name compression and
decompression library.

%prep
%setup -q
%patch1 -p1
sed -e 's/^\(BZ_EXTERN[[:space:]]\+.*[[:space:]]BZ_API[[:space:]]*([[:space:]]*\)BZ2_\(.*\)$/\1\2/' \
	<bzlib.h >bzlib_compat.h
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
find -type f -name \*.orig -delete -print
chmod a+x *.sh
%__install -pm644 %SOURCE3 .

%build
%define _optlevel 3
%add_optflags -Winline -momit-leaf-frame-pointer

gcc -Wall -Os -static -DVERSION='"%version"' %SOURCE2 -o bzlib_triggerpostun

autoreconf -fisv
%configure --enable-shared --enable-static
%make_build
%{?!__buildreqs:%{?!_without_check:%{?!_disable_check:%make_build -k check}}}

%install
%makeinstall

pushd %buildroot
	%__mkdir_p bin sbin
	mv .%_bindir/* bin/

	for f in bzip bunzip; do
		%__ln_s ../../bin/bzip2 .%_bindir/$f
		%__ln_s bzip2.1 .%_man1dir/$f.1
	done
	for f in bzip2 bunzip2 bzcat; do
		%__ln_s ../../bin/bzip2 .%_bindir/$f
	done
	for f in bzip2recover; do
		%__ln_s ../../bin/$f .%_bindir/$f
		%__ln_s bzip2.1 .%_man1dir/$f.1
	done

	%__mkdir_p ./%_lib
	mv .%_libdir/*.so.* ./%_lib
	for f in so.%v_major.%v_minor so.0.9 so.0; do
		%__ln_s libbz2.so.%version ./%_lib/libbz2.$f
	done
	%__ln_s -f ../../%_lib/libbz2.so.%version .%_libdir/libbz2.so

	# Our bzless and bzmore live in less package.
	rm bin/bz{less,more} .%_man1dir/bz{less,more}.*

	# Our bzdiff, bzcmp and bz*grep live in gzip-utils package.
	rm .{/bin,%_man1dir}/{bzdiff,bzcmp,bzgrep,bzfgrep,bzegrep}*
popd

%__install -p -m700 bzlib_triggerpostun %buildroot/sbin/

%define docdir %_docdir/%name-%version
%__rm -rf %buildroot%docdir
%__mkdir_p %buildroot%docdir
%__install -p -m644 CHANGES LICENSE README Y2K_INFO *.html %buildroot%docdir/

%post -n bzlib-devel
%install_info %name.info

%preun -n bzlib-devel
%uninstall_info %name.info

%post -n bzlib -p %post_ldconfig_sys
%postun -n bzlib -p %postun_ldconfig
%triggerpostun -n bzlib -p /sbin/bzlib_triggerpostun -- bzlib < 1:1.0.2

%files -n bzlib
/%_lib/*
/sbin/bzlib_triggerpostun
%dir %docdir
%docdir/LICENSE

%files -n bzlib-devel
%_libdir/*.so
%_includedir/*
%_infodir/*.info*

%files -n bzlib-devel-static
%_libdir/*.a

%files
/bin/*
%_bindir/b*zip*
%_bindir/bzcat
%_man1dir/b*zip*.*
%_man1dir/bzcat.*
%dir %docdir
%docdir/[CRY]*

%files doc
%dir %docdir
%docdir/*.html

%changelog
* Fri May 20 2005 Dmitry V. Levin <ldv@altlinux.org> 1:1.0.3-alt5
- bzip2-utils: obsoleted by gzip-utils package.

* Wed May 18 2005 Dmitry V. Levin <ldv@altlinux.org> 1:1.0.3-alt4
- bzip2:
  + Replaced Char* with const Char* where appropriate.
  + Trimmed usage text to bare minimum.

* Mon May 16 2005 Dmitry V. Levin <ldv@altlinux.org> 1:1.0.3-alt3
- Fixed double fclose bug in bunzip2 introduced in 1.0.3-alt1.

* Thu May 05 2005 Dmitry V. Levin <ldv@altlinux.org> 1:1.0.3-alt2
- Split autotools support patch into two parts.
- bzip2: changed -h/-L/-V options behaviour to output to stdout
  instead of stderr and cause program exit (for -L/-V) without
  processing any more options.

* Fri Apr 08 2005 Dmitry V. Levin <ldv@altlinux.org> 1:1.0.3-alt1
- Updated to 1.0.3.
- %name-utils: updated zme script.
- Rewritten autotools support patch.
- bzip2: fixed chmod/chown race condition.
- bzip2recover: fixed output file permissions.
- bzip2,bzip2recover: fixed invocation with empty arglist.
- bzlib-devel:
  + updated texinfo ducumentation.
  + disabled packaging of the bzlib_compat.h file.

* Tue Feb 08 2005 Dmitry V. Levin <ldv@altlinux.org> 1:1.0.2-alt11
- Fixed multilib (closes #4878).
- Added --show-progress option, based on patch from
  http://www.vanheusden.com/Linux/.

* Wed Apr 28 2004 Dmitry V. Levin <ldv@altlinux.org> 1:1.0.2-alt10
- Rebuilt with glibc-2.3.x.

* Tue Nov 25 2003 Dmitry V. Levin <ldv@altlinux.org> 1:1.0.2-alt9
- Do not package .la files.
- Updated URLs (#3313).

* Wed Aug 20 2003 Dmitry V. Levin <ldv@altlinux.org> 1:1.0.2-alt8
- Explicitly use old libtool for build.

* Thu Apr 24 2003 Dmitry V. Levin <ldv@altlinux.org> 1:1.0.2-alt7
- bzlib: Provides: /sbin/bzlib_triggerpostun.

* Fri Nov 01 2002 Dmitry V. Levin <ldv@altlinux.org> 1:1.0.2-alt6
- Explicitly use autoconf-2.13 and automake-1.4 for build.

* Tue Sep 03 2002 Dmitry V. Levin <ldv@altlinux.org> 1:1.0.2-alt5
- Updated %post/%postun scripts.
- Updated devel-static requirements.

* Wed Jun 12 2002 Dmitry V. Levin <ldv@altlinux.org> 1:1.0.2-alt4
- Added "Provides: /bin/bunzip, /bin/bunzip2, /bin/bzcat,
  /bin/bzip, /bin/bzip2" to bzip2 subpackage.

* Thu Jun 06 2002 Dmitry V. Levin <ldv@altlinux.org> 1:1.0.2-alt3
- Resurrected bzip2recover (thanks to Nikita Gergel).

* Thu Apr 11 2002 Dmitry V. Levin <ldv@alt-linux.org> 1:1.0.2-alt2
- bzlib: added trigger to repair compatibility symlink.

* Mon Feb 04 2002 Dmitry V. Levin <ldv@alt-linux.org> 1:1.0.2-alt1
- 1.0.2 (bugfix release).
- Moved utilities to bzip2-utils subpackage.

* Tue Nov 20 2001 Dmitry V. Levin <ldv@alt-linux.org> 1:1.0.1-alt2
- Relocated texinfo documentation to bzlib-devel subpackage.

* Fri Oct 26 2001 Dmitry V. Levin <ldv@alt-linux.org> 1:1.0.1-alt1
- Added libtool/configure support.
- Added symbol versioning.
- Implemented support for both 0.9 and 1.0 bzlib interfaces.
- Corrected libification.
- Added texinfo documentation.

* Tue Jun 05 2001 Dmitry V. Levin <ldv@altlinux.ru> 1.0.1-ipl8mdk
- Updated requires.

* Fri May 04 2001 Dmitry V. Levin <ldv@altlinux.ru> 1.0.1-ipl7mdk
- Fixed broken symlink for libbz2.so
- Moved static library to devel-static subpackage.

* Sat Jan 27 2001 Dmitry V. Levin <ldv@fandra.org> 1.0.1-ipl6mdk
- Moved bzip2 from %_bindir to /bin (but keep links to old place).
- Explicit set strip methods.

* Wed Dec 27 2000 Dmitry V. Levin <ldv@fandra.org> 1.0.1-ipl5mdk
- Commented out translations in specfile for a while.

* Sat Dec 02 2000 Dmitry V. Levin <ldv@fandra.org> 1.0.1-ipl4mdk
- Moved bzgrep from %name to %name-devel.
- Moved "Provides: libbz2.so" from bzlib to bzip2-devel.

* Tue Nov 28 2000 Dmitry V. Levin <ldv@fandra.org> 1.0.1-ipl3mdk
- Moved library into separate subpackage (bzlib).
- Added libbz2.so.1 to bzlib explicit provides list.
- Updated zme script (more robust to user input).

* Tue Aug 29 2000 Dmitry V. Levin <ldv@fandra.org> 1.0.1-ipl2mdk
- Moved bzless to less package.

* Mon Jun 26 2000 Dmitry V. Levin <ldv@fandra.org> 1.0.1-ipl1mdk
- 1.0.1
- Added URL.
- FHSification.

* Wed May 31 2000 Dmitry V. Levin <ldv@fandra.org> 1.0.0-ipl1mdk
- Revert to previous naming scheme for exported symbol (without BZ2_ prefixes).
- Provides: libbz2.so (for compatibility with old applications).

* Wed May 17 2000 Dmitry V. Levin <ldv@fandra.org> 1.0.0-1mdk.ldv
- 1.0.0

* Thu Apr 27 2000 Dmitry V. Levin <ldv@fandra.org> 1.0pre7-1mdk.ldv
- merged with Fandra version: new zme script

* Wed Apr 19 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.0pre5-1mdk
- new symlinks for Lord Jeff : bzip & bunzip
- 1.0 pre-release for Lord Chmou

* Wed Mar 22 2000 Pixel <pixel@mandrakesoft.com> 0.9.5d-7mdk
- remove provides bzip2

* Wed Mar 21 2000 Daouda LO <daouda@mandrakesoft.com> 0.9.5d-6mdk
- change to new group architecture

* Sat Mar  4 2000 Pixel <pixel@mandrakesoft.com> 0.9.5d-5mdk
- remove the silly commented out chmod in %post
(that way, bzip2 don't need /bin/sh anymore)

* Thu Mar 02 2000 Thierry Vignaud <tvignaud@mandrakesoft.com>
- fix bzme script : now it use a lot less disk space.

* Thu Oct 21 1999 Thierry Vignaud <tvignaud@mandrakesoft.com>
- add bzme script

* Tue Oct 19 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Build release.

* Thu Sep 16 1999 Thierry Vignaud <tvignaud@mandrakesoft.com>
- 0.9.5d (sanity fixes such as warnings killers casts)

* Wed Aug 25 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- No really, allow users into the docdir.. (don't put %%attr on %%doc files)

* Wed Aug 25 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- %%defattr(-,root,root,755)

* Tue Aug 17 1999 Thierry Vignaud <tvignaud@mandrakesoft.com>
- fix a bug in the spec
- clean spec

* Fri Aug 13 1999 Thierry Vignaud <tvignaud@mandrakesoft.com>
- fix bogus permissions on doc

* Wed Aug 11 1999 Thierry Vignaud <tvignaud@mandrakesoft.com>
- 0.9.5c

* Thu Aug 05 1999 Thierry Vignaud <tvignaud@mandrakesoft.com>
- updated to 0.9.5b
- remove unused patch
- merge all packages in one
- clean spec

* Tue Jul  6 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- added overly redundant provides to help clean up install.log's

* Fri May 14 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Add a bzgrep script.

* Fri Apr 16 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Mandrake adaptations.
- Add patch to permit the bunzip2 on link.

* Thu Jan 14 1999 Bernhard Rosenkraenzer <bero@microsoft.sucks.eu.org>
- version 0.9.0c

* Sun Nov 29 1998 Bernhard Rosenkraenzer <bero@microsoft.sucks.eu.org>
- remove CC="egcs" - we want to compile with pgcc
- bzip2 manpages
- build a shared libbz2.so; move libbz2 and bzlib.h to bzip2-devel

* Wed Sep 30 1998 Cristian Gafton <gafton@redhat.com>
- force compilation with egcs to avoid gcc optimization bug (thank God
  we haven't been beaten by it)

* Wed Sep 09 1998 Cristian Gafton <gafton@redhat.com>
- version 0.9.0b

* Tue Sep 08 1998 Cristian Gafton <gafton@redhat.com>
- updated to 0.9.0

* Thu Apr 09 1998 Cristian Gafton <gafton@redhat.com>
- first build for Manhattan
